% Generiert die Zeichenkette durch n-maliges ersetzen von bestimmten
% Zeichen im Axiom (Startzeichenkette) mit mglichem Zufallselement

% Cell p:
% Zeilenvektor mit den zu ersetzenden Zeichen (Precedessoren, Vorgngern)

% production1: predecessor1 p1 --> successor2 s11,s21,...,sn1
% production2: predecessor2 p2 --> successor2 s12,s22,s32,...,sg2
% production3: predecessor3 p3 --> successor3 s13,s23,s33,...,sg3
% ...
% production3: predecessor3 ph --> successor3 s1h,s2h,s3h,...,sgh

% Cell s: 
% in jeder Spalte stehen die gleichverteilten Successoren (Nachfolger) zu
% den zugehrigen Predecessoren aus Zelle s; jeder Predecessor kann
% beliebig viele Successoren haben, die alle gleichwahrscheinlich vorkommen


function string=generate(axiom,n,p,s)

abs=size(s);
h=abs(2); % Anzahl der Spalten (Predecessoren)
g=abs(1); % Anzahl der Zeilen (Sucessoren)


for i=1:n
    for k=1:h
        r=random('unid',g,1,1);      
        axiom=strrep(axiom,p{k},s{r,k});
    end
end

string=axiom;