% Unterschied generate_par_LW:
% Mglichkeit zustzlich die Lngen und Liniendicken zuberechnen

% Unterschied generate_par zu generate:
% berechnet neben dem string auch die zugehrigen Lngeneinheiten einer
% parametrisch gegebenen "production"

% BsP: A(s) --> F(s)[+A(s/R)][-A(s/R)]
% der Koeffizientenvektor muss dann coeff=[1,1/R,1/R] sein


% Generiert die Zeichenkette durch n-maliges ersetzen von bestimmten
% Zeichen im Axiom (Startzeichenkette) mit mglichem Zufallselement

% Cell p:
% Zeilenvektor mit den zu ersetzenden Zeichen (Precedessoren, Vorgngern)

% production1: predecessor1 p1 --> successor2 s11,s21,...,sn1
% production2: predecessor2 p2 --> successor2 s12,s22,s32,...,sg2
% production3: predecessor3 p3 --> successor3 s13,s23,s33,...,sg3
% ...
% production3: predecessor3 ph --> successor3 s1h,s2h,s3h,...,sgh

% Cell s: 
% in jeder Spalte stehen die gleichverteilten Successoren (Nachfolger) zu
% den zugehrigen Predecessoren aus Zelle s; jeder Predecessor kann
% beliebig viele Successoren haben, die alle gleichwahrscheinlich vorkommen


function [string,x0_vec,w0_vec]=generate_par_LW(axiom,n,p,s,coeff,x0,coeff1,w0)

abs=size(s);
h=abs(2); % Anzahl der Spalten (Predecessoren)
g=abs(1); % Anzahl der Zeilen (Sucessoren)

x0_vec_0=x0;
L_coeff=length(coeff);

w0_vec_0=w0;

for i=1:n
    for k=1:h
        r=random('unid',g,1,1);      
        
        k_vec=1;
        k_vec_alt=1;
        
        % erzeugt einen leeren Vektor "x0_vec_new" der pro zu
        % ersetzendem ('X' oder 'F') Buchstabe um L_coeff-1 lnger ist als der
        % aktuelle Vektor axiom
        % Bsp: A --> F[+A][+A]; fr jedes zu ersetzende A mssen 2 Elemente
        % mehr im neuen Vektor stehen
        
        Buchstabenzahl=sum(axiom=='X')+sum(axiom=='F')+sum(axiom=='A')+sum(axiom=='B')+sum(axiom=='C')+sum(axiom=='D');
        
        if p{k}=='X'
            L_vec=Buchstabenzahl+(L_coeff-1)*sum(axiom=='X');
        elseif p{k}=='F'
            L_vec=Buchstabenzahl+(L_coeff-1)*sum(axiom=='F');
        elseif p{k}=='A'
            L_vec=Buchstabenzahl+(L_coeff-1)*sum(axiom=='A');
        elseif p{k}=='B'
            L_vec=Buchstabenzahl+(L_coeff-1)*sum(axiom=='B');
        elseif p{k}=='C'
            L_vec=Buchstabenzahl+(L_coeff-1)*sum(axiom=='C');
        elseif p{k}=='D'
            L_vec=Buchstabenzahl+(L_coeff-1)*sum(axiom=='D');
        end
        
        x0_vec_new=zeros(1,L_vec);
        w0_vec_new=zeros(1,L_vec);
        
                
        for m=1:length(axiom)
            
            % beschreibt den Vektor "x0_vec_new": wenn im axiom der zu
            % ersetzende Buchstabe p steht ('X' oder 'F') dann wird im der
            % alte Lngenwert aus x0_vec_0 mit dem Vektor coeff multipliziert und mit durch diesen ersetzt
            % danach Position im alten Vektor um 1 weiterbewegt
            % und position im neuen Vektor um L_coeff weiterbewegt
            % (k_vec_alt=k_vec_alt+1) und (k_vec=k_vec+L_coeff)
            
            % wenn anderer Buchstabe (ohne production) in der Zeichenkette
            % steht wird dieser einfach gleich in die neue Zeichenkett
            % bernommen
            
            % weiters werden alle '[' ']' '+' und '-' ignoriert
            
            if axiom(m)==p{k}
                x0_vec_new(k_vec:(k_vec+L_coeff-1))=x0_vec_0(k_vec_alt)*coeff;
                w0_vec_new(k_vec:(k_vec+L_coeff-1))=w0_vec_0(k_vec_alt)*coeff1;
                
                k_vec=k_vec+L_coeff;
                k_vec_alt=k_vec_alt+1;
            elseif axiom(m)=='[' || axiom(m)==']' || axiom(m)=='+' || axiom(m)=='-' || axiom(m)=='$' || axiom(m)=='/'  || axiom(m)=='\' || axiom(m)=='^' || axiom(m)=='&'  || axiom(m)=='|'
                
            else
                x0_vec_new(k_vec)=x0_vec_0(k_vec_alt);
                w0_vec_new(k_vec)=w0_vec_0(k_vec_alt);
                
                k_vec=k_vec+1;
                k_vec_alt=k_vec_alt+1;
            end
        end
        
        x0_vec_0=x0_vec_new;
        w0_vec_0=w0_vec_new;
        
        axiom=strrep(axiom,p{k},s{r,k});
    end
end

string=axiom;

x0_vec=x0_vec_new;
w0_vec=w0_vec_new;